#include <iostream.h>
#include <stdio.h>
#include <search.h>
#include <stdlib.h>

class myhash {

  int 	max;
  ENTRY *hasht;

public:

	myhash(int argc, char *argv[]);
	~myhash();
	interact();

};


myhash::myhash(int argc, char *argv[]){

  if (argc!=2) {
	printf("usage: hash_test <max>\n");
  	exit(0);
  }

  max = atoi(argv[1]);

  printf("max = %d\n",max);

  hasht = new ENTRY[max];
  
  for (int i=0; i<max; ++i) {
	hasht[i].key = new char [100];
	hasht[i].data = new char [100];
  }

  if (!hcreate(max)) {
	printf("err: hcreate failed\n");
	exit(0);
  }

  for (int i=0; i<max; ++i) {
	sprintf(hasht[i].key,"key%d",i);
	sprintf(hasht[i].data,"%d",i);
	if (!hsearch(hasht[i],ENTER)){
		printf("err: hsearch ENTER failed.\n"); 
		exit(0);
	}
  }
		
}

myhash::~myhash() {

  int max;
  
  for (int i=0; i<max; ++i) {
	delete [] hasht[i].key;
	delete [] hasht[i].data;
  }

  delete [] hasht;

  hdestroy();

}

myhash::interact() {

  char key[100];
  ENTRY e;
  ENTRY *ep;
  do {
	cout << "enter key> ";
	scanf("%s",key);
	e.key = key;
	ep=hsearch(e,FIND);
	if (ep) {
		cout << "hsearch for " << key << " = " << ep->data << endl;
	} else {
		cout << "hsearch for " << key << " NO MATCH " << endl;
 	}
	
  } while (strcmp(key,"quit")!=0);

}
  
main (int argc, char *argv[]) {
	
  myhash *mh = new myhash(argc, argv);

  mh->interact();

}
