#!/usr/bin/perl

$usage = <<EOF;
usage: mua2mat.pl <muafile>
EOF

if ($#ARGV!=0) {

  print $usage;
  exit;

}

$muaf = $ARGV[0];

open(IFP,"$muaf") || die "cannot open $muaf";
open(OFP,"> $muaf.mat") || die "cannot open $muaf.mat";
while ($str=<IFP>) {
	$str =~ s/mua[\w]*\ [\d]+\ //g;
	print OFP $str;
}
close(OFP);
close(IFP);

